Code

contrib/completion: "local var=()" is misinterpreted as func-decl by zsh
[git.git] / t / lib-git-svn.sh
index a841df2a9e3a9ed64e81ab7b9778e59cfc714cad..199f22c231b5ac1479929a89cdf988ac7aff4268 100644 (file)
@@ -1,28 +1,35 @@
 . ./test-lib.sh
 
+remotes_git_svn=remotes/git""-svn
+git_svn_id=git""-svn-id
+
 if test -n "$NO_SVN_TESTS"
 then
-       test_expect_success 'skipping git-svn tests, NO_SVN_TESTS defined' :
+       skip_all='skipping git svn tests, NO_SVN_TESTS defined'
+       test_done
+fi
+if ! test_have_prereq PERL; then
+       skip_all='skipping git svn tests, perl not available'
        test_done
-       exit
 fi
 
 GIT_DIR=$PWD/.git
-GIT_SVN_DIR=$GIT_DIR/svn/git-svn
+GIT_SVN_DIR=$GIT_DIR/svn/refs/remotes/git-svn
 SVN_TREE=$GIT_SVN_DIR/svn-tree
 
 svn >/dev/null 2>&1
 if test $? -ne 1
 then
-    test_expect_success 'skipping git-svn tests, svn not found' :
+    skip_all='skipping git svn tests, svn not found'
     test_done
-    exit
 fi
 
 svnrepo=$PWD/svnrepo
 export svnrepo
+svnconf=$PWD/svnconf
+export svnconf
 
-perl -w -e "
+"$PERL_PATH" -w -e "
 use SVN::Core;
 use SVN::Repos;
 \$SVN::Core::VERSION gt '1.1.0' or exit(42);
@@ -32,15 +39,13 @@ x=$?
 if test $x -ne 0
 then
        if test $x -eq 42; then
-               err='Perl SVN libraries must be >= 1.1.0'
+               skip_all='Perl SVN libraries must be >= 1.1.0'
        elif test $x -eq 41; then
-               err='svnadmin failed to create fsfs repository'
+               skip_all='svnadmin failed to create fsfs repository'
        else
-               err='Perl SVN libraries not found or unusable, skipping test'
+               skip_all='Perl SVN libraries not found or unusable'
        fi
-       test_expect_success "$err" :
        test_done
-       exit
 fi
 
 rawsvnrepo="$svnrepo"
@@ -50,45 +55,63 @@ poke() {
        test-chmtime +1 "$1"
 }
 
-for d in \
-       "$SVN_HTTPD_PATH" \
-       /usr/sbin/apache2 \
-       /usr/sbin/httpd \
-; do
-       if test -f "$d"
-       then
-               SVN_HTTPD_PATH="$d"
-               break
+# We need this, because we should pass empty configuration directory to
+# the 'svn commit' to avoid automated property changes and other stuff
+# that could be set from user's configuration files in ~/.subversion.
+svn_cmd () {
+       [ -d "$svnconf" ] || mkdir "$svnconf"
+       orig_svncmd="$1"; shift
+       if [ -z "$orig_svncmd" ]; then
+               svn
+               return
        fi
-done
-for d in \
-       "$SVN_HTTPD_MODULE_PATH" \
-       /usr/lib/apache2/modules \
-       /usr/libexec/apache2 \
-; do
-       if test -d "$d"
+       svn "$orig_svncmd" --config-dir "$svnconf" "$@"
+}
+
+prepare_httpd () {
+       for d in \
+               "$SVN_HTTPD_PATH" \
+               /usr/sbin/apache2 \
+               /usr/sbin/httpd \
+       ; do
+               if test -f "$d"
+               then
+                       SVN_HTTPD_PATH="$d"
+                       break
+               fi
+       done
+       if test -z "$SVN_HTTPD_PATH"
        then
-               SVN_HTTPD_MODULE_PATH="$d"
-               break
+               echo >&2 '*** error: Apache not found'
+               return 1
        fi
-done
-
-start_httpd () {
-       repo_base_path="$1"
-       if test -z "$SVN_HTTPD_PORT"
+       for d in \
+               "$SVN_HTTPD_MODULE_PATH" \
+               /usr/lib/apache2/modules \
+               /usr/libexec/apache2 \
+       ; do
+               if test -d "$d"
+               then
+                       SVN_HTTPD_MODULE_PATH="$d"
+                       break
+               fi
+       done
+       if test -z "$SVN_HTTPD_MODULE_PATH"
        then
-               echo >&2 'SVN_HTTPD_PORT is not defined!'
-               return
+               echo >&2 '*** error: Apache module dir not found'
+               return 1
        fi
-       if test -z "$repo_base_path"
+       if test ! -f "$SVN_HTTPD_MODULE_PATH/mod_dav_svn.so"
        then
-               repo_base_path=svn
+               echo >&2 '*** error: Apache module "mod_dav_svn" not found'
+               return 1
        fi
 
+       repo_base_path="${1-svn}"
        mkdir "$GIT_DIR"/logs
 
        cat > "$GIT_DIR/httpd.conf" <<EOF
-ServerName "git-svn test"
+ServerName "git svn test"
 ServerRoot "$GIT_DIR"
 DocumentRoot "$GIT_DIR"
 PidFile "$GIT_DIR/httpd.pid"
@@ -101,17 +124,29 @@ LoadModule dav_svn_module $SVN_HTTPD_MODULE_PATH/mod_dav_svn.so
        SVNPath "$rawsvnrepo"
 </Location>
 EOF
+}
+
+start_httpd () {
+       if test -z "$SVN_HTTPD_PORT"
+       then
+               echo >&2 'SVN_HTTPD_PORT is not defined!'
+               return
+       fi
+
+       prepare_httpd "$1" || return 1
+
        "$SVN_HTTPD_PATH" -f "$GIT_DIR"/httpd.conf -k start
        svnrepo="http://127.0.0.1:$SVN_HTTPD_PORT/$repo_base_path"
 }
 
 stop_httpd () {
        test -z "$SVN_HTTPD_PORT" && return
+       test ! -f "$GIT_DIR/httpd.conf" && return
        "$SVN_HTTPD_PATH" -f "$GIT_DIR"/httpd.conf -k stop
 }
 
 convert_to_rev_db () {
-       perl -w -- - "$@" <<\EOF
+       "$PERL_PATH" -w -- - "$@" <<\EOF
 use strict;
 @ARGV == 2 or die "Usage: convert_to_rev_db <input> <output>";
 open my $wr, '+>', $ARGV[1] or die "$!: couldn't open: $ARGV[1]";
@@ -135,3 +170,19 @@ close $wr or die $!;
 close $rd or die $!;
 EOF
 }
+
+require_svnserve () {
+    if test -z "$SVNSERVE_PORT"
+    then
+       skip_all='skipping svnserve test. (set $SVNSERVE_PORT to enable)'
+        test_done
+    fi
+}
+
+start_svnserve () {
+    svnserve --listen-port $SVNSERVE_PORT \
+             --root "$rawsvnrepo" \
+             --listen-once \
+             --listen-host 127.0.0.1 &
+}
+